#include <stdio.h>
#include <stdlib.h>
#include <time.h>

void hostMatrixMul(float* A, float* B, float* C, int width) {
	int i,j,k;
	for (i = 0; i < width; ++i) {
		for (j = 0; j < width; ++j) {
			float sum = 0;
			for (k = 0; k < width; ++k) {
				float a = A[i*width+k];
				float b = B[k*width+j];
				sum += a*b;
			}
			C[i*width+j] = sum;
		}
	}
}

int main(int argc, char **argv) {
	int i,j;
	float *hA=NULL, *hB=NULL, *hC=NULL;
	int width=1024;

	hA = (float*)malloc(width*width*sizeof(float));
	hB = (float*)malloc(width*width*sizeof(float));
	hC = (float*)malloc(width*width*sizeof(float));

	//init matrices
	srand(time(NULL));
	for (i = 0; i < width; ++i) 
		for (j = 0; j < width; ++j) {
			/* code */
			hA[i*width+j] = rand();
			hB[i*width+j] = rand();
		}

	//do the multiplication
	clock_t start = clock();
	hostMatrixMul(hA, hB, hC, width);
	clock_t end = clock();

	double elapsed = (end-start)/(double)CLOCKS_PER_SEC;

	printf("Multiplying 2 %dx%d matrices took %f seconds\n", width, width, elapsed);

	free(hC);
	free(hB);
	free(hA);

	return 0;
}
